# coding: utf-8

"""
    Trinsic API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from trinsic_api.models.session_error_code import SessionErrorCode
from typing import Optional, Set
from typing_extensions import Self

class Session(BaseModel):
    """
    Session
    """ # noqa: E501
    id: StrictStr
    done: StrictBool = Field(description="Whether the Session is in a terminal / final state.                If this is `true`, inspect the value of `Success` to determine whether the Session was successful.")
    success: StrictBool = Field(description="Whether the Session has completed successfully.                If this is `false`, the Session is either not yet done, or has failed. Inspect `Done` and `ErrorCode` for more information.  If this is `true`, the Session has completed successfully.")
    error_code: Optional[SessionErrorCode] = Field(default=None, description="The reason for the Session's failure.                Only present if `Success` is `false`.", alias="errorCode")
    created: StrictInt = Field(description="The unix timestamp, in seconds, when this session was created")
    updated: StrictInt = Field(description="The unix timestamp, in seconds, when this session's state last changed")
    __properties: ClassVar[List[str]] = ["id", "done", "success", "errorCode", "created", "updated"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Session from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if error_code (nullable) is None
        # and model_fields_set contains the field
        if self.error_code is None and "error_code" in self.model_fields_set:
            _dict['errorCode'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Session from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "done": obj.get("done"),
            "success": obj.get("success"),
            "errorCode": obj.get("errorCode"),
            "created": obj.get("created"),
            "updated": obj.get("updated")
        })
        return _obj


